<template>
  <crud-data-table
    :items="expenses"
    :headers="columnsToShow"
    :loading="isLoading"
    :no-data-message="$t('noDataText')"
    columns-to-show
    :overlay="!selectedPeriod"
    sort-by="[category, purchaseDate, status, paymentMethod, companyNickname]"
    show-expand
  >
    <template v-slot:columnsToShow>
      <columns-to-show
        v-model="columnsToShow"
        :sorted-columns="sortedColumns"
        :default-columns="defaultColumns"
      />
    </template>

    <template v-slot:create>
      <create-expense-dialog />
    </template>

    <template v-slot:update>
      <update-expense-dialog
        @openDialog="onOpenUpdateDialogCallback = $event"
      />
    </template>

    <template v-slot:confirmationToDelete>
      <delete-expense-dialog @onDeleteExpense="onDeleteExpenseCallback = $event" />
    </template>

    <template v-slot:actions="{ item }">
      <edit-icon-btn
        class="mr-2"
        @click="onOpenUpdateDialogCallback(item)"
      />
      <delete-icon-btn
        @click="onDeleteExpenseCallback(item)"
      />
    </template>

    <template v-slot:purchaseDate="{ item: { purchaseDate } }">
      {{ purchaseDate | formatDate | symbolWhenEmpty }}
    </template>

    <template v-slot:category="{ item: { category } }">
      {{ category | symbolWhenEmpty }}
    </template>

    <template v-slot:paymentRecurrence="{ item: { paymentRecurrence } }">
      {{ paymentRecurrence | symbolWhenEmpty }}
    </template>

    <template v-slot:paymentStatus="{ item: { paymentStatus } }">
      {{ paymentStatus | symbolWhenEmpty }}
    </template>

    <template v-slot:paymentMethod="{ item: { paymentMethod } }">
      {{ paymentMethod | symbolWhenEmpty }}
    </template>

    <template v-slot:description="{ item: { description } }">
      <description-dialog
        :disabled="!description"
      >
        {{ description }}
      </description-dialog>
    </template>

    <template v-slot:numberOfInstallments="{ item: { numberOfInstallments } }">
      <installment-number :number="numberOfInstallments" />
    </template>

    <template v-slot:amountsSum="{ item: { amountsSum } }">
      {{ amountsSum | formatCurrency | symbolWhenEmpty }}
    </template>

    <template v-slot:createdAt="{ item: { createdAt } }">
      {{ createdAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:updatedAt="{ item: { updatedAt } }">
      {{ updatedAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:collapse="item">
      <installments-table :installments="item.installments" />
    </template>
  </crud-data-table>
</template>

<script>
  import { get } from 'vuex-pathify'
  import DatesMixin from '@/mixins/date'
  import MoneyMixin from '@/mixins/money'
  import UtilsMixin from '@/mixins/utils'
  import sortedColumns from './sorted-columns'
  import defaultColumns from './default-columns'
  import getTableHeaders from './table-headers'
  // components
  import ColumnsToShow from './components/ColumnsToShow'
  import CreateExpenseDialog from './components/crud/Create'
  import DeleteExpenseDialog from './components/crud/Delete'
  import UpdateExpenseDialog from './components/crud/Update'
  import InstallmentNumber from './components/InstallmentNumber'
  import DescriptionDialog from './components/DescriptionDialog'
  import InstallmentsTable from './components/installments-table/InstallmentsTable'

  export default {
    name: 'Expenses',
    components: {
      ColumnsToShow,
      InstallmentNumber,
      DescriptionDialog,
      CreateExpenseDialog,
      DeleteExpenseDialog,
      UpdateExpenseDialog,
      InstallmentsTable,
    },
    mixins: [DatesMixin, MoneyMixin, UtilsMixin],
    data () {
      return {
        sortedColumns,
        defaultColumns,
        columnsToShow: getTableHeaders(key => this.$t(key)),
        onDeleteExpenseCallback: null,
        onOpenUpdateDialogCallback: null,
      }
    },
    computed: {
      ...get('expenses', [
        'isLoading',
      ]),
      expenses () {
        return this.$store.getters['expenses/all']
      },
      selectedPeriod () {
        return this.$store.getters['periods/getSelectedPeriod']
      },
    },
    watch: {
      selectedPeriod: {
        handler () {
          this.loadExpenses()
        },
        deep: true,
      },
    },
    created () {
      this.loadExpenses()
    },
    methods: {
      loadExpenses () {
        this.$store.dispatch('expenses/getExpenses')
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          noDataText: 'Nenhuma despesa cadastrada.',
        },
        'en-US': {
          noDataText: 'No expenses registered.',
        },
      },
    },
  }
</script>
